#!/usr/bin/env python
#coding:utf-8

'''
from JiuJiang
树莓酱的操作实例
http:://www.shumeijiang.com
'''

import pyaudio
from baidu_analysis import BaiduAnalysis
import json
import sys
import RPi.GPIO as GPIO
import time

RESPEAKER_RATE = 16000
RESPEAKER_CHANNELS = 1
RESPEAKER_WIDTH = 2
CHUNK = 1024
RECORD_SECONDS = 3

#需更换已申请的key
API_KEY = 'XX'
SECRET_KEY = 'XX'

GPIO.setmode(GPIO.BCM)
GPIO.setup(12, GPIO.OUT)
GPIO.setup(13, GPIO.OUT)
GPIO.output(12, GPIO.LOW)
GPIO.output(13, GPIO.LOW)

#组装pyaudio参数
p = pyaudio.PyAudio()
stream = p.open(
            rate=RESPEAKER_RATE,
            format=p.get_format_from_width(RESPEAKER_WIDTH),
            channels=RESPEAKER_CHANNELS,
            input=True,
            start=False,)

#初始化api
baidu = BaiduAnalysis(API_KEY, SECRET_KEY)

def generator_list(list):
    for l in list:
        yield l

#获取语音并识别输出
def listen():
    stream.start_stream()
    print("-------------")
    print("【start】..")
    frames = []
    for i in range(0, int(RESPEAKER_RATE / CHUNK * RECORD_SECONDS)):
        data = stream.read(CHUNK)
        frames.append(data)
    print("【stop and send to baidu】...")
    stream.stop_stream()
    text = baidu.speech_analysis(generator_list(frames))
    text = json.loads(text)
    text = text['result']
    if not text[0]:
        print('get nothing')
        return ''

    print(text[0])
    return text[0]

#分析
analysis = True
while (analysis==True):
    try:
        outputtext = listen()
        #停止条件
        if (outputtext == u'停止识别。'):
            analysis = False 

    except Exception as e: 
        stream.close()
        p.terminate()
